#ifndef __DGLCOMMON_HPP__
#define __DGLCOMMON_HPP__

#include <GL/dglutil.hpp>

namespace DECS{
  namespace GL{

    static const DGLColor DGL_WHITE(1.0, 1.0, 1.0, 1.0);
    static const DGLColor DGL_BLACK(0.0, 0.0, 0.0, 1.0);
    static const DGLColor DGL_RED(1.0, 0.0, 0.0, 1.0);
    static const DGLColor DGL_GREEN(0.0, 1.0, 0.0, 1.0);
    static const DGLColor DGL_BLUE(0.0, 0.0, 1.0, 1.0);

    static const DGLPosition DGL_ORIGIN(0.0, 0.0, 0.0);

    class DGLObject{
    protected:
      int mode_;
      DGLColor color_;
    public:
      DGLObject():mode_(GL_POLYGON){};
      DGLObject(int mode):mode_(mode){};
      DGLObject(int mode, DGLColor color):mode_(mode), color_(color){};
      virtual void setColor(DGLColor color) = 0;
      virtual void draw() = 0;
    };
  }
}

#endif // __DGLCOMMON_HPP__
